class TimeVaryingLPBiquad(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  min_w : Tensor
  max_w : Tensor
  min_q : Tensor
  max_q : Tensor
  log_min_w : Tensor
  log_max_w : Tensor
  log_min_q : Tensor
  log_max_q : Tensor
  eps : float
  modulate_log_w : bool
  modulate_log_q : bool
  is_scriptable : bool
  def forward(self: __torch__.filters.TimeVaryingLPBiquad,
    x: Tensor,
    w_mod_sig: Optional[Tensor]=None,
    q_mod_sig: Optional[Tensor]=None,
    interp_coeff: bool=False,
    zi: Optional[Tensor]=None) -> Tuple[Tensor, Tensor, Tensor, Optional[Tensor]]:
    _0 = __torch__.util.linear_interpolate_dim
    _1 = __torch__.filters.calc_lp_biquad_coeff
    _2 = __torch__.filters.sample_wise_lpc_scriptable
    _3 = (self).calc_w_and_q(x, w_mod_sig, q_mod_sig, )
    w, q, = _3
    n_samples = torch.size(x, 1)
    if torch.__not__(interp_coeff):
      w1 = _0(w, n_samples, 1, True, )
      q1 = _0(q, n_samples, 1, True, )
      _4 = torch.eq(torch.size(x), torch.size(w1))
      if _4:
        _6 = torch.eq(torch.size(w1), torch.size(q1))
        _5 = _6
      else:
        _5 = False
      if _5:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      w0, q0 = w1, q1
    else:
      w0, q0 = w, q
    eps = self.eps
    a_coeff, b_coeff, = _1(w0, q0, eps, )
    if interp_coeff:
      a_coeff0, b_coeff0 = _0(a_coeff, n_samples, 1, True, ), _0(b_coeff, n_samples, 1, True, )
    else:
      a_coeff0, b_coeff0 = a_coeff, b_coeff
    if torch.__isnot__(zi, None):
      zi_a0 = unchecked_cast(Tensor, zi)
      zi_a : Optional[Tensor] = torch.flip(zi_a0, [1])
    else:
      zi_a = zi
    y_a = _2(x, a_coeff0, zi_a, )
    _7 = torch.__not__(bool(torch.any(torch.isinf(y_a))))
    if _7:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _8 = torch.__not__(bool(torch.any(torch.isnan(y_a))))
    if _8:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    y_ab = __torch__.filters.time_varying_fir(y_a, b_coeff0, zi, )
    _9 = torch.slice(torch.slice(a_coeff0), 1)
    a1 = torch.select(_9, 2, 0)
    _10 = torch.slice(torch.slice(a_coeff0), 1)
    a2 = torch.select(_10, 2, 1)
    a0 = torch.ones_like(a1)
    a_coeff1 = torch.stack([a0, a1, a2], 2)
    return (y_ab, a_coeff1, b_coeff0, y_a)
  def calc_w_and_q(self: __torch__.filters.TimeVaryingLPBiquad,
    x: Tensor,
    w_mod_sig: Optional[Tensor]=None,
    q_mod_sig: Optional[Tensor]=None) -> Tuple[Tensor, Tensor]:
    if torch.__is__(w_mod_sig, None):
      w_mod_sig0 = torch.zeros_like(x)
    else:
      w_mod_sig0 = unchecked_cast(Tensor, w_mod_sig)
    if torch.__is__(q_mod_sig, None):
      q_mod_sig0 = torch.zeros_like(x)
    else:
      q_mod_sig0 = unchecked_cast(Tensor, q_mod_sig)
    if torch.eq(torch.dim(x), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.dim(w_mod_sig0), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _11 = bool(torch.ge(torch.min(w_mod_sig0), 0.))
    if _11:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _12 = bool(torch.le(torch.max(w_mod_sig0), 1.))
    if _12:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.dim(q_mod_sig0), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _13 = bool(torch.ge(torch.min(q_mod_sig0), 0.))
    if _13:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _14 = bool(torch.le(torch.max(q_mod_sig0), 1.))
    if _14:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    modulate_log_w = self.modulate_log_w
    if modulate_log_w:
      log_min_w = self.log_min_w
      log_max_w = self.log_max_w
      log_min_w0 = self.log_min_w
      _15 = torch.mul(torch.sub(log_max_w, log_min_w0), w_mod_sig0)
      log_w = torch.add(log_min_w, _15)
      w = torch.exp(log_w)
    else:
      min_w = self.min_w
      max_w = self.max_w
      min_w0 = self.min_w
      _16 = torch.mul(torch.sub(max_w, min_w0), w_mod_sig0)
      w = torch.add(min_w, _16)
    modulate_log_q = self.modulate_log_q
    if modulate_log_q:
      log_min_q = self.log_min_q
      log_max_q = self.log_max_q
      log_min_q0 = self.log_min_q
      _17 = torch.mul(torch.sub(log_max_q, log_min_q0), q_mod_sig0)
      log_q = torch.add(log_min_q, _17)
      q = torch.exp(log_q)
    else:
      min_q = self.min_q
      max_q = self.max_q
      min_q0 = self.min_q
      _18 = torch.mul(torch.sub(max_q, min_q0), q_mod_sig0)
      q = torch.add(min_q, _18)
    return (w, q)
def calc_lp_biquad_coeff(w: Tensor,
    q: Tensor,
    eps: float=0.001) -> Tuple[Tensor, Tensor]:
  if torch.eq(torch.dim(w), 2):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if torch.eq(torch.dim(q), 2):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if bool(torch.ge(torch.min(w), 0.)):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _19 = torch.le(torch.max(w), 3.1415926535897931)
  if bool(_19):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if bool(torch.gt(torch.min(q), 0.)):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  stability_factor = torch.sub(1., eps)
  alpha_q = torch.div(torch.sin(w), torch.mul(q, 2))
  a0 = torch.add(alpha_q, 1.)
  a1 = torch.mul(torch.mul(torch.cos(w), -2.), stability_factor)
  a10 = torch.div(a1, a0)
  a2 = torch.mul(torch.add(torch.neg(alpha_q), 1.), stability_factor)
  a20 = torch.div(a2, a0)
  _20 = torch.all(torch.lt(torch.abs(a10), 2.))
  if bool(_20):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if bool(torch.all(torch.lt(a20, 1.))):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _21 = torch.all(torch.lt(a10, torch.add(a20, 1.)))
  if bool(_21):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _22 = torch.gt(a10, torch.neg(torch.add(a20, 1.)))
  if bool(torch.all(_22)):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  a = torch.stack([a10, a20], 2)
  _23 = torch.add(torch.neg(torch.cos(w)), 1.)
  b0 = torch.div(_23, 2.)
  b00 = torch.div(b0, a0)
  b1 = torch.add(torch.neg(torch.cos(w)), 1.)
  b10 = torch.div(b1, a0)
  _24 = torch.add(torch.neg(torch.cos(w)), 1.)
  b2 = torch.div(_24, 2.)
  b20 = torch.div(b2, a0)
  b = torch.stack([b00, b10, b20], 2)
  return (a, b)
def sample_wise_lpc_scriptable(x: Tensor,
    a: Tensor,
    zi: Optional[Tensor]=None) -> Tensor:
  if torch.eq(torch.dim(x), 2):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if torch.eq(torch.dim(a), 3):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _25 = torch.eq(torch.size(x, 0), torch.size(a, 0))
  if _25:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _26 = torch.eq(torch.size(x, 1), torch.size(a, 1))
  if _26:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  B, T, order, = torch.size(a)
  if torch.__is__(zi, None):
    zi0 = torch.new_zeros(a, [B, order])
  else:
    zi1 = unchecked_cast(Tensor, zi)
    _27 = torch.eq(torch.size(zi1), [B, order])
    if _27:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    zi0 = zi1
  _28 = torch.add(T, order)
  _29 = ops.prim.dtype(x)
  padded_y = torch.empty([B, _28], dtype=_29)
  zi2 = torch.flip(zi0, [1])
  _30 = torch.slice(torch.slice(padded_y), 1, None, order)
  _31 = torch.copy_(_30, zi2)
  _32 = torch.slice(torch.slice(padded_y), 1, order)
  _33 = torch.copy_(_32, x)
  a_flip = torch.flip(a, [2])
  for t in range(T):
    _34 = torch.add(t, order)
    _35 = torch.select(torch.slice(padded_y), 1, _34)
    _36 = torch.slice(torch.slice(a_flip), 1, t, torch.add(t, 1))
    _37 = torch.slice(torch.slice(padded_y), 1, t, torch.add(t, order))
    _38 = torch.matmul(_36, torch.unsqueeze(_37, 2))
    _39 = torch.select(torch.slice(_38), 1, 0)
    _40 = torch.sub_(_35, torch.select(_39, 1, 0))
  _41 = torch.slice(torch.slice(padded_y), 1, order)
  return _41
def time_varying_fir(x: Tensor,
    b: Tensor,
    zi: Optional[Tensor]=None) -> Tensor:
  if torch.eq(torch.dim(x), 2):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if torch.eq(torch.dim(b), 3):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _42 = torch.eq(torch.size(x, 0), torch.size(b, 0))
  if _42:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _43 = torch.eq(torch.size(x, 1), torch.size(b, 1))
  if _43:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  order = torch.sub(torch.size(b, 2), 1)
  x_padded = torch.pad(x, [order, 0])
  if torch.__isnot__(zi, None):
    zi3 = unchecked_cast(Tensor, zi)
    _44 = torch.eq(torch.size(zi3), [torch.size(x, 0), order])
    if _44:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _45 = torch.slice(torch.slice(x_padded), 1, None, order)
    _46 = torch.copy_(_45, zi3)
  else:
    pass
  x_unfolded = torch.unfold(x_padded, 1, torch.add(order, 1), 1)
  x_unfolded0 = torch.unsqueeze(x_unfolded, 3)
  b0 = torch.flip(b, [2])
  b1 = torch.unsqueeze(b0, 2)
  y = torch.matmul(b1, x_unfolded0)
  y0 = torch.squeeze(y, 3)
  return torch.squeeze(y0, 2)
